const qiniu = require('qiniu')
const chalk = require('chalk')

module.exports = function(urls, fn) {
  let context = this
  let accessKey = context.accessKey
  let secretKey = context.secretKey
  let mac = new qiniu.auth.digest.Mac(accessKey, secretKey)
  let cdnManager = new qiniu.cdn.CdnManager(mac)
  let protocolUrls = []

  urls = urls.map(function(value) {
    if (!/^http(s)?:.*/.test(value)) {
      return protocolUrls.push(`http:${value}`, `https:${value}`)
    } else {
      return protocolUrls.push(value)
    }
  })

  cdnManager.refreshUrls(protocolUrls, function(err, respBody, respInfo) {
    if (err) {
      throw err
    }
    if (Number(respInfo.statusCode) === 200) {
      var jsonBody = JSON.parse(respBody)

      console.log('\n')
      console.log(chalk.yellow('  Refresh the success CDN url：-----'))
      console.log('\n')
      Object.keys(jsonBody.taskIds || {}).map(function(value) {
        console.log(chalk.bold.rgb(255, 232, 94)(`${value}\n`))
      })

      fn && fn.apply(context, [err, respBody, respInfo])
    } else {
      console.log(chalk.red('   Refresh urls failure.'))
      console.log(respBody)
    }

  })
}

