const qiniu = require('qiniu')

module.exports = function(bucket, proFix, fn) {
  let context = this
  let accessKey = context.accessKey
  let secretKey = context.secretKey
  let mac = new qiniu.auth.digest.Mac(accessKey, secretKey)
  let config = new qiniu.conf.Config()
  let bucketManager = new qiniu.rs.BucketManager(mac, config)
  let options = {
    prefix: proFix
  }
  let deleteOperations = []

  config.zone = qiniu.zone.Zone_z0

  bucketManager.listPrefix(bucket, options, function(err, respBody, respInfo) {
    if (err) {
      console.log(err)
      throw err
    }
    if (Number(respInfo.statusCode) === 200) {
      respBody.items.forEach(function(item) {
        deleteOperations.push(qiniu.rs.deleteOp(bucket, item.key))
      })

      bucketManager.batch(deleteOperations, function(err, respBody, respInfo) {
        if (err) {
          throw err
        }
        fn ? fn.apply(context, [mac]) : ''
      })
    }
  })

}